
;'***********************'
;' ANN code 17/07/2018
;' author: Michela '     
;'***********************'

;outputfile
openw,1,'..\output.txt' ;add the path to write the file containing the output

;read input file
file=file_search('..\input_nn.txt',count=n) ;add the path of input file
input=read_ascii(file(0))

;read weights file
filewgt=file_search('..\weights.txt',count=n) ;add the path of weight file
wgt=read_ascii(filewgt(0))

WEIGHTJ=wgt.field1(0:7,*)
WEIGHTK=wgt.field1(8,*)

;define variables
ni=7 
nh=10
no=1
input1=FLTARR(ni+1)+1.0000000 ;+1 for the bias node

f1=0.7045336
f2=-3.0222764
f3=-3.0000000

OUT=FLTARR(n_elements(input.field1(0,*)))
FOR i=0, n_elements(input.field1(0,*))-1 DO BEGIN

input1(0)=0.5*(COS((2*!PI*(input.field1(0,i)))/365)+1)
input1(1)=0.5*(SIN((2*!PI*(input.field1(0,i)))/365)+1)

a1=33.1883000; real minimum of training dataset
a2=46.1655600; arbitrary maximum
a3=31.5288850; arbitrary minimum
input1(2)=(input.field1(1,i)-a1)/(a2-a3)

b1=-3.8047000; real minimum of training dataset
b2=34.2565650; arbitrary maximum
b3=-3.6144650; arbitrary minimum
input1(3)=(input.field1(2,i)-b1)/(b2-b3)


c1=12.8500000; real minimum of training dataset
c2=30.4158750; arbitrary maximum
c3=12.2075000; arbitrary minimum
input1(4)=(input.field1(3,i)-c1)/(c2-c3)

d1=0.0060800; real minimum of training dataset
d2=3.6473850; arbitrary maximum
d3=0.0057760; arbitrary minimum
input1(5)=(input.field1(4,i)-d1)/(d2-d3)

;How to scale the data into interval [0,1]
e1=3.0000000; real minimum of training dataset
e2=157.5000000; arbitrary maximum
e3=2.8500000; arbitrary minimum
input1(6)=(input.field1(5,i)-e1)/(e2-e3)

case1=FLTARR(ni + 1)
case2=FLTARR(nh + 1)
netj=FLTARR(nh + 1)
netk=FLTARR(no)
outj=FLTARR(nh + 1)+1 
outk=FLTARR(no)
bit=FLTARR(ni + 1)
target=FLTARR(no)

FOR j=0, nh-1 DO BEGIN
  FOR k=0, ni+1-1 DO BEGIN
    case1(k)=input1(k)*(weightj(k,j))
  ENDFOR
  netj(j)=TOTAL(case1)
  outj(j)=1/(1+exp(-netj(j)))
ENDFOR

FOR j=0,no-1 DO BEGIN
  FOR k=0, nh+1-1 DO BEGIN
    case2(k)=outj(k)*weightk(k)

  ENDFOR
  netk(j)=TOTAL(case2)
  outk(j)=1/(1+exp(-netk(j)))
  outk(j)=(outk(j)*(f1-f2))+f3
  outk_end=10^outk(j)
ENDFOR
OUT(i)=outk_end
ENDFOR
printf,1,out,FORMAT='(f8.5)'
close,/all
END
